LeetCode 350: 两个数组的交集 II Intersection of Two Arrays II

简介: 题目:给定两个数组,编写一个函数来计算它们的交集。Given two arrays, write a function to compute their intersection.示例 1:输入: nums1 = [1,2,2,1], nums2 = [2,2]输出: [2,2]示例 2:输入: nums1 = [4,9,5], nums2 = [9,4,9,8,4]输出: [4,9]说明:输出结果中每个元素出现的次数,应与元素在两个数组中出现的次数一致。

题目:

给定两个数组,编写一个函数来计算它们的交集。

Given two arrays, write a function to compute their intersection.

示例 1:

输入: nums1 = [1,2,2,1], nums2 = [2,2]
输出: [2,2]

示例 2:

输入: nums1 = [4,9,5], nums2 = [9,4,9,8,4]
输出: [4,9]

说明:

  • 输出结果中每个元素出现的次数,应与元素在两个数组中出现的次数一致。
  • 我们可以不考虑输出结果的顺序。

Note:

  • Each element in the result should appear as many times as it shows in both arrays.
  • The result can be in any order.

进阶:

  • 如果给定的数组已经排好序呢?你将如何优化你的算法?
  • 如果 nums1 的大小比 nums2 小很多,哪种方法更优?
  • 如果 nums2 的元素存储在磁盘上,磁盘内存是有限的,并且你不能一次加载所有的元素到内存中,你该怎么办?

Follow up:

  • What if the given array is already sorted? How would you optimize your algorithm?
  • What if nums1's size is small compared to nums2's size? Which algorithm is better?
  • What if elements of nums2 are stored on disk, and the memory is limited such that you cannot load all elements into the memory at once?

解题思路:

​ 暴力解题就不说了。

  • 哈希表:

利用哈希映射求得其中一个数组每个数字出现的频次。遍历另一个数组,每遇到相同数字,其存储频次减一,若频次为 0,则移出哈希映射。如:

输入 nums1 = [4, 9, 5], nums2 = [9, 4, 9, 8, 4 }
计算 nums1 频次: { 4:1, 9:1, 5:1 },Key = {4 , 9, 5 }
遍历 nums2:
9 存在于 Key,9 频次 -1 为 0,9 移出 HashMap:{ 4:1, 5:1 }
4 存在于 Key,4 频次 -1 为 0,4 移出 HashMap:{ 5:1 }
9 不存在于 Key,跳过
8 不存在于 Key,跳过
...
输出:{9, 4}
  • 双指针:

先把两个数组排序,定义两个指针 i, j ,移动指针

  • 如果 nums1 [i] == nums2 [j],则该数共有。
  • 如果不等,则移动元素值小的指针。

如:

输入 nums1 = [ 4, 9, 5 ], nums2 = [ 9, 4, 9, 8, 4 ]
排序 nums1 = [ 4, 5, 9 ], nums2 = [ 4, 4, 8, 9, 9 ]
双指针遍历:[ 4, 5, 9],[ 4, 4, 8, 9, 9 ]
                              ^                 ^
 4 = 4, 存入 res = [4], 移动双指针: [ 4, 5, 9],[ 4, 4, 8, 9, 9 ]
                                                                        ^                 ^
5 > 4, 移动指向 4 的指针:[ 4, 5, 9],[ 4, 4, 8, 9, 9 ]
                                                       ^                      ^
5 < 8, 移动指向 5 的指针:[ 4, 5, 9],[ 4, 4, 8, 9, 9 ]
                                                            ^                 ^

9 > 8, 移动指向 8 的指针:[ 4, 5, 9],[ 4, 4, 8, 9, 9 ]
                                                            ^                      ^

9 = 9, 存入 res = [4, 9], 移动双指针: [ 4, 5, 9 ],[ 4, 4, 8, 9, 9 ]
                                                                                   ^                        ^
超过 nums1 长度,结束,返回 res

回答进阶问题:

  1. 双指针法主要耗时操作就是排序操作的排序算法。对于有序数组当然使用双指针解题。
  2. 在一个数组长度远小于另一个数组时,哈希表解题更优,只需哈希统计长度较小的数组的元素频次,遍历长数组即可。时间复杂度取决于长数组长度。如果用双指针法,对长数组的排序将消耗更多时间。
  3. 如果内存有限,只能选择双指针法或暴力破解,无需额外空间复杂度。使用哈希表时在最坏情况下:每个数字只出现一次,HashMap 元素频次统计后,其大小可能大于内存容量。

哈希表解题:

Java:

class Solution {
    public int[] intersect(int[] nums1, int[] nums2) {
        HashMap<Integer, Integer> map = new HashMap<>();
        List<Integer> list = new ArrayList<>();//动态数组
        for (Integer num : nums1) map.put(num, map.getOrDefault(num, 0) + 1);//统计元素出现频次
        for (Integer num : nums2) {//遍历另一个数组
            if (map.containsKey(num)) {
                int tmp = map.get(num)-1;//频次减一
                if (tmp == 0) map.remove(num);//频次为 0 时,移出 HashMap
                else map.put(num, tmp);//否则更新频次
                list.add(num);//加入动态数组
            }
        }
        //转为数组并返回
        int size=list.size();
        int[] res = new int[size];
        for (int i = 0; i < size; i++) res[i] = list.get(i);
        return res;
    }
}

Python:

class Solution:
    def intersect(self, nums1: List[int], nums2: List[int]) -> List[int]:
        count = dict(collections.Counter(nums1))# 自带库统计元素出现频次,并转为 Dict 类型

        res = []
        for num in nums2:# 遍历另一个数组
            if num in count:
                count[num] -= 1# 词频减一
                res.append(num)
                if count[num] <= 0:# 词频为 0 时,移出字典
                    count.pop(num)
        return res

双指针解题:

Java:

class Solution {
    public int[] intersect(int[] nums1, int[] nums2) {
        List<Integer> list = new ArrayList<>();
        Arrays.sort(nums1);//排序数组
        Arrays.sort(nums2);
        int i = 0, j = 0;//定义指针
        while (i < nums1.length && j < nums2.length) {
            if (nums1[i] < nums2[j]) i++;//移动较小数的指针
            else if (nums1[i] > nums2[j]) j++;//移动较小数的指针
            else {
                //两数相等则为交集,存入动态数组,移动双指针
                list.add(nums1[i]);
                i++;
                j++;
            }
        }
        //转为数组并返回
        int[] res = new int[list.size()];
        for (int k = 0; k < list.size(); k++) res[k] = list.get(k);
        return res;
    }
}

Python:

class Solution:
    def intersect(self, nums1: List[int], nums2: List[int]) -> List[int]:
        i, j, nums1_size, nums2_size = 0, 0, len(nums1), len(nums2)# 定义指针,计算数组长度
        nums1, nums2, res = sorted(nums1), sorted(nums2), []# 排序数组,初始化返回数组 res
        while i < nums1_size and j < nums2_size:# 循环条件为指针不溢出
            if nums1[i] < nums2[j]:# 移动数值较小的指针
                i += 1
            elif nums1[i] > nums2[j]:# 移动数值较小的指针
                j += 1
            else:
                res.append(nums1[i])# 数值相等,则为交集,移动双指针
                i += 1
                j += 1
        return res

欢迎关注微.信..公.众.号: 爱写Bug

爱写Bug.png

目录
相关文章
|
1月前
|
算法
【数组相关面试题】LeetCode试题
【数组相关面试题】LeetCode试题
|
4天前
|
C++
【力扣】2562. 找出数组的串联值
【力扣】2562. 找出数组的串联值
|
1月前
|
存储 算法
《LeetCode 热题 HOT 100》——寻找两个正序数组的中位数
《LeetCode 热题 HOT 100》——寻找两个正序数组的中位数
|
1月前
|
存储
力扣刷题-最大子数组和
力扣刷题-最大子数组和
10 1
|
1月前
leetcode2967. 使数组成为等数数组的最小代价
leetcode2967. 使数组成为等数数组的最小代价
20 0
|
1月前
|
算法 搜索推荐
LeetCode刷题---215. 数组中的第K个最大元素(双指针,快速选择)
LeetCode刷题---215. 数组中的第K个最大元素(双指针,快速选择)
|
1月前
|
Go C++
【力扣】2645. 构造有效字符串的最小插入数(动态规划 贪心 滚动数组优化 C++ Go)
【2月更文挑战第17天】2645. 构造有效字符串的最小插入数(动态规划 贪心 滚动数组优化 C++ Go)
30 8
|
22天前
|
机器学习/深度学习 算法
力扣刷题日常(一)
力扣刷题日常(一)
20 2
|
1月前
|
存储 索引
《LeetCode》—— LeetCode刷题日记
《LeetCode》—— LeetCode刷题日记
|
1月前
|
搜索推荐
《LeetCode》——LeetCode刷题日记3
《LeetCode》——LeetCode刷题日记3